# www.Tricks12345.com....Pandas Examples.. Template Last Updated August 5, 2018
#==========Import the Libraries====================
import pandas as pd;
import openpyxl;
#==========Create the DataFrame====================
df = pd.read_csv('Sales.txt', sep = ',')
df3 = pd.read_csv('Sales.txt',   index_col = 'Item')
#=============Retrieve data based on conditions============
query = [('All Rows', df.ix[:],'df.ix[:]'),\
          ('SecondtoLast', df.ix[1:],'df.ix[1:]'),\
         ('SpecifiedRows', df.ix[0:3],'df.ix[0:3]'), \
         ('ExceptLastrow', df.iloc[0:-1],'df.iloc[0:-1]'), \
         ('PriceColumn', df.loc[1:3,['Item','Price']],'df.loc[1:3,["Item','Price"]]'),\
         ('Item_Price', df.ix[1:3,['Item','Price']],"df.ix[1:3,['Item','Price']]"),\
         ('Every Second Row', df.ix[::2], 'df.ix[::2]]'),\
         ('Every Third Row', df.ix[::3], 'df.ix[::3]]'), \
         ('Secondrow fourth row', df.ix[[1,3]], 'df.ix[[1,3]]'), \
         ('FirstThirdFourth', df.ix[[0,2,3]], 'df.ix[[0,2,3]]'), \
         ('RowsNotInOrder', df.ix[[3,2,1]], 'df.ix[[3,2,1]]'), \
         ('HeadDF', df.head(), 'df.head()'), \
         ('HeadRowsSelect', df.head(3), 'df.head(3)'), \
         ('TailDF', df.tail(), 'df.tail()'), \
         ('TailThree', df.tail(3), 'df.tail(3)'), \
         ('FirstThree_iloc', df.iloc[0:3], 'df.iloc[0:3]'), \
         ('SecondThirdRows_iloc', df.iloc[1:3], 'df.iloc[1:3]'),\
         ('Rows Disorder', df.iloc[[4,2,1,3]], 'df.iloc[[4,2,1,3]]'),\
         ('AllColumnsiloc', df.iloc[1:3,:], 'df.iloc[1:3,:]'),\
         ('ColumnSliceiloc', df.iloc[1:3,1:3], 'df.iloc[1:3,1:3]'),\
         ('RowColnSliceloc', df.loc[[2,1,4],['Item','Qty']], "df.loc[[2,1,4],[''Item','Qty'']]"),\
         ('ColumnsSliceloc', df.loc[1:3,'Item':'Price'], "df.loc[1:3,'Item':'Price']"),\
         ('ColumnsUptoloc', df.loc[1:5,:'Price'], "df.loc[1:5,':'Price']"),\
         ('ColumnsFromloc', df.loc[1:7,'Item':], "df.loc[1:7,'Item':]"),\
         ('RowsFromThreeloc', df.loc[2:,'Item':], "df.loc[2:,'Item':]"),\
         ('UptoThirdRowloc', df.loc[:2,'Item':], "df.loc[:2,'Item':]"),\
         ('BananaToPencil', df3.ix['Banana':'Pencil',['Qty','Price']],"df3.ix['Banana':'Pencil',['Qty','Price']]"),\
         ('AfterGrapes', df3.ix['Grapes':],"df3.ix['Grapes':]"), \
         ('AfterBanana', df3.loc['Banana':,['Qty','Price']], "df3.loc['Banana':,['Qty','Price']]")]

#==Delete the existing sheets in workbook before running the program=======================
#======================================================================
wkb = openpyxl.load_workbook('Python_Pandas_Notepad.xlsm', read_only=False, keep_vba=True)
for sheet in  wkb.sheetnames:
        worksh = wkb[sheet]
        if  worksh.title !=  'Introduction':  
           del wkb[worksh.title]
#==============Run the Program======================         
for i in range(len(query)):
    a = list(df.shape); r = a[0]; c = a[1]; shcount =  len(wkb.sheetnames)
    Newsh = wkb.create_sheet(index = int(shcount))
    for  rowdata in range(r):         
        Newsh.cell(row = int(rowdata)+5, column =  2).value = rowdata
        for columndata in range(c):
            result =  df.iloc[rowdata,columndata]        
            Newsh.cell(row = int(rowdata)+5, column = int(columndata)+3).value = result        
    q = len((list(df.columns)))
    for h in range(q):
         Newsh.cell(row = 3, column = int(h)+3).value = int(h)
         Newsh.cell(row = 4, column = int(h)+3).value = df.columns[h]
    Newsh.title =  query[i][0]
    #==================result table==================
    if i <= 25:
            df1 = query[i][1]; b = list(df1.shape); rows = b[0]; cols = b[1]     
            for  rowsdata in range(rows):         
                 for colsdata in range(cols):
                    output =  df1.iloc[rowsdata,colsdata]  
                    Newsh.cell(row = int(rowsdata)+5, column = int(colsdata)+8).value = output        
            z = len((list(df1.columns)))
            for h in range(z):          
                 Newsh.cell(row = 4, column = int(h)+8).value = df1.columns[h]
    elif i >= 26:
            df1 = query[i][1]; b = list(df1.shape); rows = b[0]; cols = b[1]     
            for  rowsdata in range(rows):         
                 for colsdata in range(cols):
                    output =  df1.iloc[rowsdata,colsdata]  
                    Newsh.cell(row = int(rowsdata)+5, column = int(colsdata)+9).value = output        
            z = len((list(df1.columns)))
            for h in range(z):          
                 Newsh.cell(row = 4, column = int(h)+9).value = df1.columns[h]
            n = len((list(df1.index)))
            for k in range(n):          
                 Newsh.cell(row = int(k)+5, column = 8).value = df1.index[k]
                 
    Newsh.cell(row = 2, column = 7).value = str(query[i][2])
    Newsh.cell(row = 20, column = 3).value = 'www.Tricks12345.com'
    wkb.save('Python_Pandas_Notepad.xlsm')    
print('completed')

